/* HTMLParser.h */

#define END					-1
#define MAXLEXBUFFER		512

// Token List

/* EOF */
#define TK_EOF				0

/* Text 1 */
#define TK_TEXT				1

/* Tag 2 - 99 */
#define TK_TAG				2
#define TK_TAG_UNKNOWN		3
#define TK_TAG_B			4
#define TK_TAG_I			5
#define TK_TAG_U			6
#define TK_TAG_P			7
#define TK_TAG_A			8

#define TK_TAG_H1			10
#define TK_TAG_H2			11
#define TK_TAG_H3			12
#define TK_TAG_H4			13
#define TK_TAG_H5			14
#define TK_TAG_H6			15

/* ETag 100 - 199 */
#define TK_ETAG				100
#define TK_ETAG_UNKNOWN		101
#define TK_ETAG_B			102
#define TK_ETAG_I			103
#define TK_ETAG_U			104
#define TK_ETAG_P			105
#define TK_ETAG_A			106

#define TK_ETAG_H1			110
#define TK_ETAG_H2			111
#define TK_ETAG_H3			112
#define TK_ETAG_H4			113
#define TK_ETAG_H5			114
#define TK_ETAG_H6			115

struct TOKEN {
	int id;
	TCHAR* p;
};

class CHTMLParser
{	
	static int (CHTMLParser::*pfSemRut[7][7])(TCHAR);

	TCHAR*	in;
	TCHAR	lexBuffer[MAXLEXBUFFER];
	int		lexBufferLength;
	int		nLineCount;
	int		nLineTokenCount;
	bool	bAddNewLine;
	UINT	nCurrentPos;
	UINT	nMaxPos;
protected:
	int GetNextChar();
	void MoveCharPos(int nOffset);
	int GetEvent(int c);
	int GetSpecialChar();
	void ErrorMessage(TCHAR* szMsg);

public:
	CHTMLParser();
	int GetToken(TOKEN* pToken);
	bool Open(LPCTSTR input);
	bool Open(LPTSTR pBuffer, UINT nBufferSize);
	void Close();

public:
	int OnText(TCHAR c);
	int OnEndTextByEOF(TCHAR c);
	int OnEndTextByTag(TCHAR c);
	int OnTag(TCHAR c);
	int OnEndTag(TCHAR c);
	int OnETag(TCHAR c);
	int OnEndETag(TCHAR c);
	int OnEOF(TCHAR c);
};