// MyScrollView.cpp : implementation file
//

#include "stdafx.h"
#include "ITBReader.h"
#include "MyScrollView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyScrollView

IMPLEMENT_DYNCREATE(CMyScrollView, CView)

CMyScrollView::CMyScrollView()
{
}

CMyScrollView::~CMyScrollView()
{
}


BEGIN_MESSAGE_MAP(CMyScrollView, CView)
	//{{AFX_MSG_MAP(CMyScrollView)
	ON_WM_VSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyScrollView drawing

void CMyScrollView::OnDraw(CDC* pDC)
{
	//CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CMyScrollView diagnostics

#ifdef _DEBUG
void CMyScrollView::AssertValid() const
{
	CView::AssertValid();
}

void CMyScrollView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMyScrollView message handlers

void CMyScrollView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	int nPixelInc = 0, nPosInc = 0;
	int nCurPos = GetScrollPos(SB_VERT);
	int nMax = GetScrollLimit(SB_VERT);
	CRect clipRect;
	GetClientRect(clipRect);
	clipRect.top = GetRowHeight(0);
	
	switch (nSBCode) {
		case SB_LINEDOWN: 
			if (nCurPos < nMax) {
				nPosInc = 1;
				nPixelInc = -GetRowHeight(nCurPos);
			}
			break;
		case SB_LINEUP:
			if (nCurPos > 1) {
				nPosInc = -1;
				nPixelInc = GetRowHeight(nCurPos - 1);
			}
			break;
		case SB_PAGEDOWN: {
			int i = nCurPos, y = 0;

			while (i < nMax) {
				y += GetRowHeight(i);
				if (y + clipRect.top <= clipRect.bottom) {
					i++;
					nPixelInc = -y;
				}
				else break;
			}
			nPosInc = i - nCurPos;
			break;
		}
		case SB_PAGEUP: {
			int i = nCurPos;

			while (i > 1 && clipRect.bottom - nPixelInc > clipRect.top)
				nPixelInc += GetRowHeight(--i);

			nPosInc = i - nCurPos;
			break;
		}
		case SB_THUMBTRACK:
			if (nCurPos < nPos) {
				while (nCurPos + nPosInc < nPos && nCurPos + nPosInc < nMax) 
				{
					nPixelInc -= GetRowHeight(nCurPos + nPosInc);
					nPosInc++;
				}
			}
			else if (nCurPos > nPos){
				nPosInc--;
				while (nCurPos + nPosInc >= nPos && nCurPos + nPosInc >= 1) {
					nPixelInc += GetRowHeight(nCurPos + nPosInc);
					nPosInc--;
				}
				nPosInc++;
			}
			break;
		default:
			nPosInc = 0;
	}

	if (nPosInc)
	{	
		if (nCurPos <= m_editCell.GetRow() && 
			nCurPos + nPosInc > m_editCell.GetRow())
			m_editCell.HideCaret();

		ScrollWindow(0, nPixelInc, NULL, clipRect);
		SetScrollPos(SB_VERT, nCurPos + nPosInc);
		
		UpdateWindow();
	}
		
	CView::OnVScroll(nSBCode, nPos, pScrollBar);
}
