// PictureDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ITBReader.h"
#include "PictureDlg.h"
#include "LibraryConnection.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define DEFAULTSCALEFACTOR	0.5

/////////////////////////////////////////////////////////////////////////////
// CPictureDlg dialog

CPictureDlg::CPictureDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPictureDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPictureDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	
	m_pDIBInfo = NULL;
	
	m_pParentWnd = NULL;	// Just a known value
}


void CPictureDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPictureDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPictureDlg, CDialog)
	//{{AFX_MSG_MAP(CPictureDlg)
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_SIZING()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_REQUEST_COMPLETED, OnRequestCompleted)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPictureDlg message handlers
BOOL CPictureDlg::Create(CWnd* pParent, UINT uBook, int nPage, UINT uIndex, 
		CString& strName, bool bLarge, 
		LONG lWidth, LONG lHeight, DWORD dwSize)
{
	/*STORE_INFORMATION si;
	
	GetStoreInformation(&si);

	if (si.dwFreeSize <= dwSize) {
		AfxMessageBox((bLarge) ? 
			IDS_LARGE_PICTURE_NOT_ENOUGH_MEMORY:
			IDS_SMALL_PICTURE_NOT_ENOUGH_MEMORY);
		return FALSE;
	}*/

	if (lWidth && lHeight)
		m_fScaleFactor = (float)lWidth / (float)lHeight;
	else
		m_fScaleFactor = DEFAULTSCALEFACTOR;

	m_bDownloading = true;
	m_bDownloadError = false;

	if (!CDialog::Create(CPictureDlg::IDD, pParent))
		return FALSE;

	m_pParentWnd = pParent;

	SetWindowText(strName);
	
	// Request the picture data
	REQUESTINFO* pRequestInfo = new REQUESTINFO;
	if (!pRequestInfo) return FALSE;
	
	if (bLarge)
		pRequestInfo->strObjectName.Format(_T("/ITBLibrary.dll?GetLargePicture?Book=%d&Page=%d&Index=%d"),
			uBook, nPage, uIndex);
	else
		pRequestInfo->strObjectName.Format(_T("/ITBLibrary.dll?GetSmallPicture?Book=%d&Page=%d&Index=%d"),
			uBook, nPage, uIndex);

	pRequestInfo->lpszVerb = NULL;
	pRequestInfo->nReadFuncType = RFT_DIB;
	pRequestInfo->hwndRequester = GetSafeHwnd();
	pRequestInfo->nPage = nPage;
	pRequestInfo->uBook = uBook;

	AfxBeginThread(InternetRequestThreadProc, pRequestInfo);

	return TRUE;
}

void CPictureDlg::OnSizing(UINT nSide, LPRECT lpRect)
{
	// Redimensionado proporcional al dib asociado
	
	double dDelta;
	CRect rcImgWnd, rcDlgWnd;
	
	double dRel = double(m_pDIBInfo->lpBMIH->biHeight) / m_pDIBInfo->lpBMIH->biWidth;
	CWnd* pImgWnd = GetDlgItem(IDC_IMG);
	
	pImgWnd->GetWindowRect(rcImgWnd);
	GetWindowRect(rcDlgWnd);
	
	int nMargin = (rcDlgWnd.bottom - rcDlgWnd.top) - (rcImgWnd.bottom - rcImgWnd.top) ;

// nSide meaning:
// 1: left,			2: right
// 3: top,			6: bottom
// 4: lefttop,		5: righttop
// 7: leftbottom,	8: rightbottom, 

	if(nSide == 3 || nSide == 6)
	{	
		int nNewHeight = (lpRect->bottom - lpRect->top) - nMargin;
		dDelta = double(nNewHeight) / dRel;
		lpRect->right = int(dDelta) + lpRect->left;
	}
	else if(nSide == 4 || nSide == 5)
	{
		int nNewWidth = lpRect->right - lpRect->left;
		dDelta = double(nNewWidth) * dRel;
		lpRect->top = lpRect->bottom - int(dDelta) - nMargin;
	}
	else 
	{
		int nNewWidth = lpRect->right - lpRect->left;
		dDelta = double(nNewWidth) * dRel;
		lpRect->bottom = int(dDelta) + lpRect->top + nMargin;
	}

	CDialog::OnSizing(nSide, lpRect);
}

void CPictureDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	CWnd* pImgWnd = GetDlgItem(IDC_IMG);

	if (pImgWnd) {
		pImgWnd->MoveWindow(0,0, cx, cy, FALSE);
		Invalidate(FALSE);
	}
}

void CPictureDlg::OnPaint() 
{
	CPaintDC dlgDC(this); // device context for painting
	CWnd* pImgWnd = GetDlgItem(IDC_IMG);
	ASSERT(pImgWnd);
	
	CDC* pDC = pImgWnd->GetDC();
	
	CRect rect;
	pImgWnd->GetClientRect(rect);

	if (m_bDownloading || m_bDownloadError) 
	{
		CSize sz;
		int x, y;
		TCHAR* pTxt = (m_bDownloading) ? 
			TEXT("Downloading..."):TEXT("Download error");

		// Since SetTextAlign is not supported, 
		// let's do it by ourself.
		sz = pDC->GetTextExtent(pTxt, _tcslen(pTxt));

		if (sz.cx >= rect.Width() - 2)
			x = rect.left + 2;
		else
			x = rect.left + (rect.Width() - sz.cx) / 2;

		if (sz.cy >= rect.Height() - 2)
			y = rect.top + 2;
		else
			y = rect.top + (rect.Height() - sz.cy) / 2;

		pDC->SetBkColor(RGB(255, 255, 255));
		pDC->Rectangle(rect);
		CRect clip(x, y, rect.right - 4, rect.bottom - 4);
		pDC->ExtTextOut(x, y, ETO_CLIPPED, clip, pTxt, NULL);
	}
	else if (m_pDIBInfo)
	{
		HDC dcMem = ::CreateCompatibleDC(pDC->GetSafeHdc());
		HBITMAP hbmOld = (HBITMAP) ::SelectObject(dcMem, 
							m_pDIBInfo->hDIBSection);

		::StretchBlt(pDC->GetSafeHdc(), 
			rect.left, rect.top, 
			rect.Width(), rect.Height(), 
			dcMem, 0, 0,
			m_pDIBInfo->lpBMIH->biWidth, 
			m_pDIBInfo->lpBMIH->biHeight, 
			SRCCOPY); 

		::SelectObject(dcMem, hbmOld);
		::DeleteDC(dcMem);
	}

	pImgWnd->ReleaseDC(pDC);
}

void CPictureDlg::OnCancel()
{
	if (m_pParentWnd) 
		m_pParentWnd->PostMessage(WM_CLOSE_PICTURE_DLG);
	else
		DestroyWindow();
}

LRESULT CPictureDlg::OnRequestCompleted(WPARAM wParam, LPARAM lParam)
{
	REQUESTINFO* pRequestInfo = (REQUESTINFO*)lParam;

	if (wParam == TRUE) 
	{
		ASSERT(pRequestInfo->pBuffer);
		ASSERT(pRequestInfo->dwBufferSize > 0);
	
		if (m_pDIBInfo) delete m_pDIBInfo;
		m_pDIBInfo = (DIBINFO*) pRequestInfo->pBuffer;
		m_bDownloadError = false;
	}
	else
		m_bDownloadError = true;

	delete pRequestInfo;
	
	m_bDownloading = false;

	Invalidate();
	
	return 0L;
}

BOOL CPictureDlg::DestroyWindow() 
{
	if (m_pDIBInfo) {
		delete m_pDIBInfo;	// See the DIBINFO destructor
		m_pDIBInfo = NULL;
	}
	
	return CDialog::DestroyWindow();
}

BOOL CPictureDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CRect rect, mainFrmRect;
	
	GetWindowRect(rect);
	AfxGetMainWnd()->GetWindowRect(mainFrmRect);

	int cx = (int)((float)rect.Height() * (float)m_fScaleFactor);
	int cy;
	
	if (mainFrmRect.Width() - cx > 0) 
	{
		cy = rect.Height();
	}
	else 
	{
		cy = (int)((float)rect.Width() / (float)m_fScaleFactor);	
		cx = rect.Width();	
	}

	SetWindowPos(&wndTopMost, 0, 0, cx, cy, 0);
	CenterWindow();
	
	return TRUE;
}
