#if !defined(AFX_PICTUREVIEW_H__BE39B066_AA85_11D2_B4E5_000000000000__INCLUDED_)
#define AFX_PICTUREVIEW_H__BE39B066_AA85_11D2_B4E5_000000000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// PictureView.h : header file
//

#include <afxtempl.h>
#include "PictureWnd.h"
/////////////////////////////////////////////////////////////////////////////
// CPictureView view

struct DIBINFO;
struct REQUESTINFO;
struct PICTUREINFO;

class CPictureView : public CScrollView
{
protected:
	CPictureView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CPictureView)

// Attributes
protected:
	int m_nLeftMargin;
	int m_nRightMargin;
	int m_nInterPicGap;

	CList<CPictureWnd*, CPictureWnd*> m_picList;
	CPictureWnd* m_pActiveNotePicWnd;

// Operations
protected:
	int AddPicture(const PICTUREINFO& pi, CRect& rect);
	void AddErrorPicture(const PICTUREINFO& pi, CRect& rect);
	bool ParsePicHeaderLine(char* szLine, PICTUREINFO& pi);
	void Empty();
	int GetPictureHeight(int nIndex);
	void SetScrollPage(int nPage);
	void OffsetPictures(int cy);

public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPictureView)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	virtual void OnInitialUpdate();     // first time after construct
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CPictureView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CPictureView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	afx_msg LRESULT OnRequestCompleted(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnNoteClick(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnAddNote(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnDeleteNote(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnPushPicture(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PICTUREVIEW_H__BE39B066_AA85_11D2_B4E5_000000000000__INCLUDED_)

