#if !defined(AFX_PICTUREWND_H__BE39B068_AA85_11D2_B4E5_000000000000__INCLUDED_)
#define AFX_PICTUREWND_H__BE39B068_AA85_11D2_B4E5_000000000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// PictureWnd.h : header file
//
/////////////////////////////////////////////////////////////////////////////
// Data types and structures

#define DEFAULTSCALEFACTOR	0.5

enum OBJTYPE {OT_UNK, OT_DIB, OT_AVI, OT_WAV, OT_OLE, OT_JPG, OT_GIF};

struct PICTUREINFO
{
	UINT	uBook;
	int		nPage;
	UINT	uIndex;
	CString strName;
	OBJTYPE nType;
	bool	bHasNote;
	DWORD	dwSmallSize;
	DWORD	dwLargeSize;
	LONG	lSmallWidth;
	LONG	lSmallHeight;
	LONG	lLargeWidth;
	LONG	lLargeHeight;
};

struct REQUESTINFO;
struct PICTUREINFO;

/////////////////////////////////////////////////////////////////////////////
// CPictureWnd window

class CPictureWnd : public CWnd
{
private:
// Static members
	static bool		s_bIsClassRegistered;
	static int		s_nShadowHeight;
	static int		s_nShadowWidth;
	static int		s_nBottomBandHeight;
	static HICON	s_hLargeNoteIcon;
	static HICON	s_hSmallNoteIcon;
	static HICON	s_hLargeActiveNoteIcon;
	static HICON	s_hSmallActiveNoteIcon;
	static HFONT	s_labelFont;

// Graphic data
	bool m_bIsPressed;
	bool m_bIsNoteActive;
	bool m_bSmallNoteIcon;

// Picture data
	UINT		 m_uBook;
	int			 m_nPage;
	UINT		 m_uIndex;
	CString		 m_strNote;
	bool		 m_bHasNote;
	CRect		 m_picRect;

protected:
	CString		 m_strName;
	float		 m_fScaleFactor;

// Construction
public:
	CPictureWnd();
	CPictureWnd(CString& strName);

// Operations
protected:
	void RecalcPictureRect();
	void DrawNoteIcon(CDC* pDC);
	virtual void OnPictureSelect() = 0;
	virtual void OnPictureUnselect() = 0;

public:
	void PushPicture(bool bPush = true);
	void CalcBottomPt(CRect* pRect);
	void RecalcShadow(int nNewWidth);
	void ScaleMove(CRect* pRect, BOOL bRepaint = TRUE);
	void SetNoteActive(bool bState = true);
	void GetNoteIconRect(CRect& rect);
	int GetPicturePage() {return m_nPage;}
	UINT GetPictureIndex() {return m_uIndex;}
	UINT GetPictureBook() {return m_uBook;}

// Virtual functions
	virtual BOOL Create(const PICTUREINFO& pi, CRect& rect, CWnd* pParentWnd, UINT nID);
	virtual void OnDraw(CDC* pDC, const CRect& rect) = 0;
	virtual void OnDownloadCompleted(WPARAM wParam, LPARAM lParam) = 0;
	virtual void OnProperties() = 0;

public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPictureWnd)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CPictureWnd();

	// Generated message map functions
protected:
	//{{AFX_MSG(CPictureWnd)
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	afx_msg void OnAddDeleteNote();
	afx_msg void OnSaveNote();
	afx_msg void OnCopyPicture();
	afx_msg void OnGetPictureProperties();
	afx_msg LRESULT OnRequestCompleted(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnClosePictureDlg(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PICTUREWND_H__BE39B068_AA85_11D2_B4E5_000000000000__INCLUDED_)
